﻿Imports C1.C1Word
Imports C1.C1Word.Objects

Public Class Form1
    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        C1WordDocument1.Info.Title = "Simple Text Sample"
        Dim font As New Font("Cambria", 24, FontStyle.Bold)
        C1WordDocument1.Load(Application.StartupPath + "\..\..\demo.docx")
        C1WordDocument1.AddBookmark("bmk1")
        C1WordDocument1.AddBookmarkStart("bmk2")
        C1WordDocument1.AddBookmarkEnd("bmk2")
        AddTextBeforeBookmark(C1WordDocument1, C1WordDocument1.MainSection.Content)
        C1WordDocument1.Save("simple.docx")
        Process.Start("simple.docx")
    End Sub
    Private Function AddTextBeforeBookmark(C1WordDocument1 As C1WordDocument, content As RtfInnerContent, Optional insert As Boolean = True) As String
        Dim text = String.Empty
        For i As Integer = 0 To content.Count - 1
            If TypeOf content(i) Is RtfParagraph Then
                text = AddTextBeforeBookmark(C1WordDocument1, DirectCast(content(i), RtfParagraph).Content, False)
            ElseIf TypeOf content(i) Is RtfBookmarkStart Then
                Dim bookmark = TryCast(content(i), RtfBookmark)
                If (bookmark.Name = "bmk2") Then
                    text = "ex novo"
                End If
            End If
            If insert AndAlso text <> String.Empty Then
                Dim paragraph = C1WordDocument1.GetParagraph(text)
                content.Insert(i, paragraph)
                text = String.Empty
                i += 1
            End If
        Next
        Return text
    End Function
End Class
